# Functions for parsing command-line options
#
# Copyright (C) 2013  Patrick "P. J." McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

[ "x${_GETOPT_SM+set}" = 'xset' ] && return 0
_GETOPT_SM=1

get_options()
{
	local optstring=
	local prefix=
	local opt=

	if [ "x${running_cmd}" = 'x' ]; then
		optstring="${OPTSTRING}"
		prefix='opt_'
	else
		eval "optstring=\"\${cmd_${running_cmd}_optstring}\""
		prefix="cmd_${running_cmd}_opt_"
	fi

	unset OPTARG
	while getopts "${optstring}" opt; do
		if [ "x${opt}" != 'x?' ]; then
			eval "${prefix}${opt}=\"\${OPTARG:-true}\""
		else
			return 1
		fi
		unset OPTARG
	done

	return 0
}
