#!/bin/sh
#
# match_plat() tests
#
# Copyright (C) 2014  Patrick "P. J." McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

. "${srcdir}/tests/common.sh"

use archplat

do_test()
{
	local plat="${1}"
	local plat_field="${2}"
	local result="${3}"

	if match_plat "${plat}" "${plat_field}"; then
		if [ "x${result}" = 'xfalse' ]; then
			printf 'False positive:\n'
			printf '  plat:       %s\n  plat_field: %s\n' \
				"${plat}" "${plat_field}"
			tests_es=1
		fi
	else
		if [ "x${result}" = 'xtrue' ]; then
			printf 'False negative:\n'
			printf '  plat:       %s\n  plat_field: %s\n' \
				"${plat}" "${plat_field}"
			tests_es=1
		fi
	fi
}

do_test all 'all' true

do_test dev 'any' true

do_test dev 'any all' true

do_test all 'any all' true

do_test dev 'dev' true

do_test dev 'ao751h' false

do_test all 'any' false

do_test any 'all' false
